
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>ArcGIS Engine开发入门教程 / iVAN</title>

    <meta name="description" content="ArcGIS Engine开发入门教程 利用ArcGIS Engine.VS .NET和Windows控件开发GIS应用 Dixon整理 此过程说明适合那些使用.NET建立和部署应用的开发者,它描述了使用ArcGIS控件建立和部署应用的方法和步骤. 你可以在下面的目录下找到相应的样例程序: &lt;安装目录&gt;/DeveloperKit/Samples/Developer_Guide_Scenarios/ ArcGIS_Engine/Building_an_ArcGIS_Control_Application/Map_Viewer ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">ArcGIS Engine开发入门教程</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>利用ArcGIS Engine、VS .NET和Windows控件开发GIS应用</strong></p>
<p>Dixon整理</p>
<p>此过程说明适合那些使用.NET建立和部署应用的开发者，它描述了使用ArcGIS控件建立和部署应用的方法和步骤。</p>
<p>你可以在下面的目录下找到相应的样例程序：</p>
<p>&lt;安装目录&gt;/DeveloperKit/Samples/Developer_Guide_Scenarios/ ArcGIS_Engine/Building_an_ArcGIS_Control_Application/Map_Viewer</p>
<p><strong>注：</strong><em>ArcGIS样例程序不包含在ArcGIS Engine开发工具包“典型”安装方式中。如果你没有安装它们，则可以重新运行开发工具包安装向导，选择“定制”或“修改”方式，并选择软件开发包下的样例项进行安装。</em></p>
<p><strong>一、项目描述</strong></p>
<p>利用视窗控件建立应用程序的目标是演示并使你熟悉在微软Visual Studio .NET API中使用标准ArcGIS控件开发和部署GIS应用所需的步聚。本节中使用了Visual Studio .NET开发环境中的MapControl、  PageLayoutControl、TOCControl和ToolbarControl等视窗控件。COM、Java和C++程序员应该参考如下章节：<em><a href="http://www.863s.com/list.asp?Unid=135#_%E5%88%A9%E7%94%A8ActiveX%E5%BB%BA%E7%AB%8B%E5%BA%94%E7%94%A8%E7%A8%8B%E5%BA%8F" rel="external nofollow noreferrer">利用</a>ActiveX建立应用程序、<a href="http://www.863s.com/list.asp?Unid=135#_%E5%88%A9%E7%94%A8%E5%8F%AF%E8%A7%86%E5%8C%96JavaBeans%E5%BB%BA%E7%AB%8B%E5%BA%94%E7%94%A8%E7%A8%8B%E5%BA%8F" rel="external nofollow noreferrer">利用可视化</a>JavaBeans建立应用程序、<a href="http://www.863s.com/list.asp?Unid=135#_%E5%BB%BA%E7%AB%8B%E5%91%BD%E4%BB%A4%E8%A1%8C%E6%96%B9%E5%BC%8F%E7%9A%84Java%E5%BA%94%E7%94%A8" rel="external nofollow noreferrer">建立命令行方式的</a>Java应用和<a href="http://www.863s.com/list.asp?Unid=135#_%E5%BB%BA%E7%AB%8B%E5%91%BD%E4%BB%A4%E8%A1%8C%E6%96%B9%E5%BC%8F%E7%9A%84C++%E5%BA%94%E7%94%A8" rel="external nofollow noreferrer">建立命令行方式的</a>C++应用</em>。</p>
<p>本节演示了创建查看ArcMap和ArcGIS桌面应用图形文档的GIS应用程序的步骤。此节包含了以下技术：</p>
<p>l在微软Visual Studio .NET中加载和嵌入ArcGIS控件。</p>
<p>l向PageLayoutControl和MapControl中加载图形文档。</p>
<p>l设置ToolbarControl和TOCControl的绑定控件。</p>
<p>l处理窗口缩放。</p>
<p>l向ToolbarControl添加ArcGIS Engine命令和工具。</p>
<p>l创建弹出式菜单</p>
<p>l在TOCControl中管理标签编辑</p>
<p>l在MapControl中绘制图形。</p>
<p>l为MapControl、PageLayoutControl和ToolbarControl创建定制工具。</p>
<p>l用户化ToolbarControl。</p>
<p>l在Windows操作系统中部署应用。</p>
<p><strong>二、概述</strong></p>
<p>本方案使用微软Visual Studio .NET开发环境加以实现，并使用了ESRI interop程序集(Interop Assemblies)，它服务于被放置在.NET窗体上的、位于.NET 窗体控件(.NET Windows Controls)中的ArcGIS控件，这些程序集在托管的.NET代码和非托管的COM代码之间起了桥梁作用。对COM ArcGIS控件(COM ArcGIS Controls)成员的引用都要经过Interop程序集，然后到达实际的COM对象。同样，也从COM对象经过Interop程序集到达.NET应用程序。每个ArcGIS Engine控件具有方法、属性与事件，它们能够被控件嵌入的容器(如，.NET窗体)访问。每个控件对象及其功能可以与其他ESRI ArcObjects和自定义控件组合使用，创建用户化的客户应用程序。</p>
<p>此方案是使用了C#和Visual Basic .NET两种语言创建，但以下技术实现集中倾向于C#方案。许多开发者可能会感觉用Visual Basic .NET更舒服，那是因为他们已经比较熟悉Visual Basic 6.0代码，然而，对于Java和C++程序员来说，他们将会觉得对C#程序语言的语法更熟悉。无论你使用哪种开发环境，对于使用ArcGIS控件的好坏既依赖于你的编程环境技术，也依赖于你所掌握的ArcObjects技术。</p>
<p>在本方案中，使用ToolbarControl、TOCControl、PageLayoutControl和MapControl来为应用程序提供用户界面。这些ArcGIS控件与其他ArcObjects和ArcGIS Engine命令被开发者一起使用，用来创建一个GIS视窗应用。</p>
<p><strong>三、设计</strong></p>
<p>此方案在设计时，首先强调了ArcGIS 控件如何互相之间进行交互，其次，向开发者解释说明了ArcGIS 控件对象模型的一部分。</p>
<p>每个.NET ArcGIS Engine控件包含有一套能够被嵌入其内的窗口即时访问的属性页。这些属性些为控件属性和方法的选择提供了捷径，并且允许开发者不写任何代码即可创建一个应用程序。本方案并没有使用属性页，而是采用写代码的方式建立应用程序。关于属性页的更进一步的信息，请参考<em>ArcGIS开发帮助(ArcGIS Developer Help)</em>。</p>
<p><strong>四、条件需求</strong></p>
<p>要顺利地完成以下方案，你需要以下条件（对于部署的需求将在后续的部署章节涉及到）：</p>
<p>l安装具有授权文件的ArcGIS Engine开发工具包(Developer Kit)，使之能够用于开发。</p>
<p>l安装有微软Visual Studio .NET 2003开发环境和微软.NET Framework 1.1及其相应协议。</p>
<p>l熟悉微软Windows操作系统和Microsoft Visual Studio .NET的工作知识，会用C#或Visual Basic .NET编程语言。当然，此方案中提供了一些如何在Microsoft Visual Studio .NET中使用ArcGIS控件的信息，但它不能替代对开发环境的培训。</p>
<p>l不需要对ESRI其它软件有足够的经验，但如果以前对ArcObjects有所接触并对ArcGIS应用(如，ArcCatalog，ArcMap)有一个基本了解，则对于开发更有利。</p>
<p>l访问来自本方案的样例数据和代码，它位于：</p>
<p>&lt;安装目录&gt;/DeveloperKit/Samples/Developer_Guide_Scenarios/ ArcGIS_Engine/Building_an_ArcGIS_Control_Application/Map_Viewer</p>
<p>本方案中使用到的控件和库如下：</p>
<table>
<tbody>
<tr>
<td>
<br />lAxMapControl</p>
</td>
<td>
<br />lAxTOCControl</p>
</td>
</tr>
<tr>
<td>
<br />lAxPageLayoutControl</p>
</td>
<td>
<br />lAxToolbarControl</p>
</td>
</tr>
<tr>
<td>
<br />lESRI.ArcGIS.Carto</p>
</td>
<td>
<br />lESRI.ArcGIS.System</p>
</td>
</tr>
<tr>
<td>
<br />lESRI.ArcGIS.Display</p>
</td>
<td>
<br />lESRI.ArcGIS.SystemUI</p>
</td>
</tr>
<tr>
<td>
<br />lESRI.ArcGIS.Geometry</p>
</td>
<td>
<br />lESRI.ArcGIS.Utility</p>
</td>
</tr>
<tr>
<td>
<br />lesriMapControl</p>
</td>
<td>
<br />lesriTOCControl</p>
</td>
</tr>
<tr>
<td>
<br />lesriPageLayoutControl</p>
</td>
<td>
<br />lesriToolbarControl</p>
</td>
</tr>
</tbody>
</table>

<h3>五、实现</h3>
<p>下面的实现过程中提供了你成功完成方案所需所有代码。假设你对于开发环境已经有了一定的知识，所以下面没有逐步地详细介绍如何用Microsoft Visual Studio .NET开发应用。</p>
<h4>(一)加载ArcGIS控件</h4>
<p>在你为应用程序编写代码之前，应该先将应用程序将用到的ArcGIS控件和其他ArcGIS Engine库引用装载到开发环境之中。</p>
<p>1.启动Visual Studio .NET，并从新建项目对话框中创建一个新的Visual C# “Windows应用程序”项目。</p>
<p>2.将项目命名为“Controls”，并选择位置存取该项目。</p>
<p>3.在“工具箱”的“Windows窗体”标签栏中单击右键，然后从上下文菜单中选择“添加/移除项(I)…”。</p>
<p>4.在“自定义工具箱”中选择“.NET Framework组件”，并复选“AxMapControl”，“AxPageLayoutControl”，“AxTOCControl”和“AxToolbarControl”，单击<strong>确定</strong>按钮。这样所选择的控件将显示在<strong>工具箱</strong>的<strong>Windows窗体</strong>标签栏中。</p>
<p>5.单击<strong>项目</strong>菜单，并选择“添加引用(<u>R</u>)…”。</p>
<p>6.在<strong>添加引用</strong>对话框中，双击“ESRI.ArcGIS.Carto”，“ESRI.ArcGIS.Display”，“ESRI.ArcGIS.Geometry”，“ESRI.ArcGIS.System”，“ESRI.ArcGIS.SystemUI”，“ESRI.ArcGIS.Utility”。单击<strong>确定</strong>。</p>
<p><em>注：对于ESRI .NET程序集，将通过具体实例来说明，并使用.NET框架提供的COM传送服务从你的C#项目中调用ESRI对象库中的实体对象。</em></p>
<h4>(二)在容器中嵌入ArcGIS控件</h4>
<p>在你能够访问每个控件的事件、属性和方法之前，需要将控件嵌入到.NET容器中。一旦将控件嵌入窗体内，它们将图形化应用程序的用户界面。</p>
<p>1.在设计模式下打开.NET窗体。</p>
<p>2.双击工具箱Windows标签栏中的AxMapControl控件，将MapControl加入到窗体上。</p>
<p>3.再将AxPageLayoutControl、AxTOCControl和AxToolbarControl如上添加到窗体中。</p>
<p>4.重新调整窗体上各个控件的大小和位置，调整结果如下所示。</p>
<p>5.在窗体上双击显示窗体代码窗口，在代码窗口的顶部增加“using”命令：</p>
<p>using System;</p>
<p>using System.Windows.Forms;</p>
<p>// ArcGIS Engine引用</p>
<p>using ESRI.ArcGIS.SystemUI;</p>
<p>using ESRI.ArcGIS.Carto;</p>
<p>using ESRI.ArcGIS.Display;</p>
<p>using ESRI.ArcGIS.Geometry;</p>
<p>using ESRI.ArcGIS.esriSystem;</p>
<p>using ESRI.ArcGIS.ToolbarControl;</p>
<p>using ESRI.ArcGIS.TOCControl;</p>
<p><em>注：需注意C#是区分大小写的。当你键入“ESRI.”时，智能敏感的自动完成功能将允许你通过按Tab键完成下一节。</em></p>
<h4>(三)加载Map文档到MapControl与PageLayoutControl</h4>
<p>单独的数据层或者使用ArcMap、ArcGIS桌面应用程序产生的图形文档，能够被加载到MapControl和PageLayoutControl中。你可以加载样例图形文档，或者加载你自己的图形文档。后面你将增加一个浏览图形文档的对话框。</p>
<p>1.选择Form_Load事件，并输入下列代码（如果你使用你自己的图形文档，要替换为正确的文件名）：</p>
<p>// 使用相对路径向PageLayoutControl加载一个图形文档</p>
<p>string filename = @"../../../../../../../../Data//ArcGIS_Engine_Developer_Guide//gulf of st. lawrence.mxd";</p>
<p>if ( axPageLayoutControl1.CheckMxFile(filename) )</p>
<p>{</p>
<p>axPageLayoutControl1.LoadMxFile(filename, "");</p>
<p>}</p>
<p>2.在设计模式显示窗体并从属性窗选择axPageLayoutControl1控件，显示axPageLayoutControl事件。在OnPageLayoutReplaced事件上双击向代码窗口添加该事件的处理函数。</p>
<p>3.在axPageLayoutControl1_OnPageLayoutReplaced事件中键入以下向MapControl加载样例图形文档的代码。当文档被装载入PageLayoutControl时OnPageLayoutReplaced事件将会被触发。</p>
<p>privatevoid axPageLayoutControl1_OnPageLayoutReplaced(object sender, ESRI.ArcGIS.PageLayoutControl.IPageLayoutControlEvents_OnPageLayoutReplacedEvent e)</p>
<p>{</p>
<p>// 加载同样的文档到MapControl</p>
<p>axMapControl1.LoadMxFile(axPageLayoutControl1.DocumentFilename, null, null);</p>
<p>// 设置MapControl显示范围至数据的全局范围</p>
<p>axMapControl1.Extent = axMapControl1.FullExtent;</p>
<p>}</p>
<h4>(四)设置ToolbarControl与TOCControl控件的绑定控件</h4>
<p>对于此应用程序，TOCControl和ToolbarControl控件将与PageLayoutControl相互协作，而不是MapControl。为此PageLayoutControl必须设置为绑定控件。TOCControl使用绑定的ActiveView显示图形、图层和符号。而位于ToolbarControl上的任何命令、工具或菜单项会受绑定控件的显示影响。</p>
<p>1.在Form_Load事件中的加载文档代码的后面键入以下红色部分内容：</p>
<p>privatevoid Form1_Load(object sender, System.EventArgs e)</p>
<p>{</p>
<p>// 使用相对路径向PageLayoutControl加载一个图形文档</p>
<p>string filename = @"../../../../../../../../Data//ArcGIS_Engine_Developer_Guide//gulf of st. lawrence.mxd";</p>
<p>if ( axPageLayoutControl1.CheckMxFile(filename) )</p>
<p>{</p>
<p>axPageLayoutControl1.LoadMxFile(filename, "");</p>
<p>}</p>
<p>// 设置绑定控件</p>
<p>axTOCControl1.SetBuddyControl(axPageLayoutControl1);</p>
<p>axToolbarControl1.SetBuddyControl(axPageLayoutControl1);</p>
<p>}</p>
<p>2.生成并运行应用程序。图形文档被加载到PageLayoutControl，并且TOCControl列出了图形文档中的数据图层。使用TOCControl通过复选和取消复选框控制图层的可见性。默认地，图形文档的焦点图(focus map)被装入MapControl控件。在这种当前情况下，ToolbarControl控件显示是空的，因为没有为它添加任何命令。试着缩放窗体，你会注意到控件不会改变尺寸。</p>
<h4>(五)处理窗口缩放</h4>
<p>当窗口在运行时进行缩放时，PageLayoutControl和MapControl不会自动改变自身的尺寸。要改变控件的尺寸以便它们总是与匹配窗口的范围，你必须将控件锚定在窗口上。如果PageLayoutControl或MapControl包含大量的数据，在窗口缩放期间重绘这些数据显得相当重要。为了提高执行效率，你可以禁止数据重绘直到缩放操作完成后再重绘之。在缩放时，可以用一个可伸缩的位图来替代重绘数据。</p>
<p>1.在设计模式显示窗体并从属性窗口中选择axPageLayoutControl1。单击Anchor属性，将axPageLayoutControl1锚定在窗体的顶、左、底和右部。</p>
<p>2.锚定axMapControl控件到窗体的顶、左和底部。</p>
<p>3.在Form_Load事件的开头增加以下代码：</p>
<p>// 当缩放时禁止重绘</p>
<p>this.SetStyle(ControlStyles.EnableNotifyMessage, true);</p>
<p>4.向类增加以下常量：</p>
<p>publicclass Form1 : System.Windows.Forms.Form</p>
<p>{</p>
<p>// ……</p>
<p>privateconstint WM_ENTERSIZEMOVE = 0x231;</p>
<p>privateconstint WM_EXITSIZEMOVE = 0x232;</p>
<p>// ……</p>
<p>}</p>
<p>5.向重载的OnNotifyMessage方法中增加下列代码：</p>
<p>protectedoverridevoid OnNotifyMessage(Message m)</p>
<p>{</p>
<p>base.OnNotifyMessage (m);</p>
<p>// 以下为手工添加的代码</p>
<p>if ( m.Msg == WM_ENTERSIZEMOVE)</p>
<p>{</p>
<p>axMapControl1.SuppressResizeDrawing(true, 0);</p>
<p>axPageLayoutControl1.SuppressResizeDrawing(true, 0);</p>
<p>}</p>
<p>elseif ( m.Msg == WM_EXITSIZEMOVE)</p>
<p>{</p>
<p>axMapControl1.SuppressResizeDrawing(false, 0);</p>
<p>axPageLayoutControl1.SuppressResizeDrawing(false, 0);</p>
<p>}</p>
<p>}</p>
<p>6.生成并运行应用程序，试着缩放窗口。</p>
<p><em>注：禁止缩放时重画方法是通过检查发送到窗体的Windows消息工作的。当窗口开发缩放时，Windows发送WM_ENTERSIZEMOVE窗口消息。此时，我们禁止在MapControl和PageLayoutControl上绘制图形，而是使用“stretchy bitmap”绘制。当Windows发送WM_EXITSIZEMOVE消息时，窗体结束缩放，这时我们全部重绘新的范围。</em></p>
<h4>(六)向ToolbarControl增加命令</h4>
<p>ArcGIS Engine提供了120多个命令和工具，它们与MapControl、PageLayoutControl和ToolbarControl直接相互协作。这些命令和工具为你提供了大量的经常使用的地图导航、图形管理、地物选择等方面的GIS功能。现在将在你的应用程序中增加这些命令和工具的一部分。</p>
<p>1.在Form_Load事件中的加载文档代码之前添加如下代码。</p>
<p>// 增加打开档命令</p>
<p>string progID;</p>
<p>progID = "esriControlToolsGeneric.ControlsOpenDocCommand";</p>
<p>axToolbarControl1.AddItem(progID, -1, -1, false, 0,</p>
<p>esriCommandStyles.esriCommandStyleIconOnly);</p>
<p>// 增加PageLayout导航命令</p>
<p>progID = "esriControlToolsPageLayout.ControlsPageZoomInTool";</p>
<p>axToolbarControl1.AddItem(progID, -1, -1, true, 0,</p>
<p>esriCommandStyles.esriCommandStyleIconOnly);</p>
<p>progID = "esriControlToolsPageLayout.ControlsPageZoomOutTool";</p>
<p>axToolbarControl1.AddItem(progID, -1, -1, true, 0,</p>
<p>esriCommandStyles.esriCommandStyleIconOnly);</p>
<p>progID = "esriControlToolsPageLayout.ControlsPagePanTool";</p>
<p>axToolbarControl1.AddItem(progID, -1, -1, true, 0,</p>
<p>esriCommandStyles.esriCommandStyleIconOnly);</p>
<p>progID = "esriControlToolsPageLayout.ControlsPageZoomWholePageCommand";</p>
<p>axToolbarControl1.AddItem(progID, -1, -1, true, 0,</p>
<p>esriCommandStyles.esriCommandStyleIconOnly);</p>
<p>progID = "esriControlToolsPageLayout.ControlsPageZoomPageToLastExtentBackCommand";</p>
<p>axToolbarControl1.AddItem(progID, -1, -1, true, 0,</p>
<p>esriCommandStyles.esriCommandStyleIconOnly);</p>
<p>progID = "esriControlToolsPageLayout.ControlsPageZoomPageToLastExtentForwardCommand";</p>
<p>axToolbarControl1.AddItem(progID, -1, -1, true, 0,</p>
<p>esriCommandStyles.esriCommandStyleIconOnly);</p>
<p>// 增加地图导航命令</p>
<p>progID = "esriControlToolsMapNavigation.ControlsMapZoomInTool";</p>
<p>axToolbarControl1.AddItem(progID, -1, -1, true, 0,</p>
<p>esriCommandStyles.esriCommandStyleIconOnly);</p>
<p>progID = "esriControlToolsMapNavigation.ControlsMapZoomOutTool";</p>
<p>axToolbarControl1.AddItem(progID, -1, -1, true, 0,</p>
<p>esriCommandStyles.esriCommandStyleIconOnly);</p>
<p>progID = "esriControlToolsMapNavigation.ControlsMapPanTool";</p>
<p>axToolbarControl1.AddItem(progID, -1, -1, true, 0,</p>
<p>esriCommandStyles.esriCommandStyleIconOnly);</p>
<p>progID = "esriControlToolsMapNavigation.ControlsMapFullExtentCommand";</p>
<p>axToolbarControl1.AddItem(progID, -1, -1, true, 0,</p>
<p>esriCommandStyles.esriCommandStyleIconOnly);</p>
<p>// 使用相对路径向PageLayoutControl加载一个图形文档</p>
<p>// ……</p>
<p>2.生成并运行应用程序。现在ToolbarControl包含了ArcGIS Engine命令和工具，你可以使用它们导航加载到PageLayoutControl中的图形文档。使用页面布局命令对当前的页面布局进行导航控制，要对存在于数据框架中的数据进行导航则使用地图命令。利用找开文档命令可以浏览并加载其他的图形文档。</p>
<h4>(七)给PageLayoutControl添加弹出式菜单</h4>
<p>与给跟绑定控件协作的ToolbarControl增加ArcGIS Engine命令一样，按照前面的步骤，你也可以从ArcGIS Engine命令创建弹出式菜单。下面将向你的应用程序中增加与PageLayoutControl协作的弹出式菜单。当在PageLayoutControl可视区域点击鼠标右键的时候，弹出式菜单将显示。</p>
<p>1.向类中添加如下的成员变量（红色部分）：</p>
<p>publicclass Form1 : System.Windows.Forms.Form</p>
<p>{</p>
<p>private ESRI.ArcGIS.MapControl.AxMapControl axMapControl1;</p>
<p>private ESRI.ArcGIS.PageLayoutControl.AxPageLayoutControl axPageLayoutControl1;</p>
<p>private ESRI.ArcGIS.TOCControl.AxTOCControl axTOCControl1;</p>
<p>private ESRI.ArcGIS.ToolbarControl.AxToolbarControl axToolbarControl1;</p>
<p>private IToolbarMenu m_ToolbarMenu = new ToolbarMenuClass(); // 弹出式菜单</p>
<p>// ……</p>
<p>2.在Form_Load事件中向ToolbarControl增加命令代码的后面加载文档代码的前面增加如下代码。</p>
<p>privatevoid Form1_Load(object sender, System.EventArgs e)</p>
<p>{</p>
<p>// 前面是增加地图导航的代码……</p>
<p>// 共享ToolbarControl的命令池</p>
<p>m_ToolbarMenu.CommandPool = axToolbarControl1.CommandPool;</p>
<p>// 向ToolbarMenu增加命令</p>
<p>progID = "esriControlToolsPageLayout.ControlsPageZoomInFixedCommand";</p>
<p>m_ToolbarMenu.AddItem(progID, -1, -1, false,</p>
<p>esriCommandStyles.esriCommandStyleIconAndText);</p>
<p>progID = "esriControlToolsPageLayout.ControlsPageZoomOutFixedCommand";</p>
<p>m_ToolbarMenu.AddItem(progID, -1, -1, false,</p>
<p>esriCommandStyles.esriCommandStyleIconAndText);</p>
<p>progID = "esriControlToolsPageLayout.ControlsPageZoomWholePageCommand";</p>
<p>m_ToolbarMenu.AddItem(progID, -1, -1, false,</p>
<p>esriCommandStyles.esriCommandStyleIconAndText);</p>
<p>progID = "esriControlToolsPageLayout.ControlsPageZoomPageToLastExtentBackCommand";</p>
<p>m_ToolbarMenu.AddItem(progID, -1, -1, true,</p>
<p>esriCommandStyles.esriCommandStyleIconAndText);</p>
<p>progID = "esriControlToolsPageLayout.ControlsPageZoomPageToLastExtentForwardCommand";</p>
<p>m_ToolbarMenu.AddItem(progID, -1, -1, false,</p>
<p>esriCommandStyles.esriCommandStyleIconAndText);</p>
<p>// 设置与PageLayoutControl挂接</p>
<p>m_ToolbarMenu.SetHook(axPageLayoutControl1);</p>
<p>// 后面是加载图形文档的代码……</p>
<p>// ……</p>
<p>3.在设计模式显示窗体并从属性窗口中选择axPageLayoutControl1，显示axPageLayoutControl事件。双击OnMouseDown事件，向代码窗口中增加事件处理代码。</p>
<p>4.在axPageLayoutControl1_OnMouseDown事件中增加如下代码：</p>
<p>privatevoid axPageLayoutControl1_OnMouseDown(object sender, ESRI.ArcGIS.PageLayoutControl.IPageLayoutControlEvents_OnMouseDownEvent e)</p>
<p>{</p>
<p>// 弹出ToolbarMenu</p>
<p>if ( e.button == 2)</p>
<p>{</p>
<p>m_ToolbarMenu.PopupMenu(e.x, e.y, axPageLayoutControl1.hWnd);</p>
<p>}</p>
<p>}</p>
<p>5.生成并运行应用程序。在PageLayoutControl的显示区域单击右键以显示弹出菜单，并为页面布局导航。</p>
<h4>(八)在TOCControl中控制标签编辑</h4>
<p>TOCControl默认允许用户自动地切换图层的可见性并改变显示在目录表中的名称。你可以增加代码防止用户在编辑名称时输入空的字符串。</p>
<p>1.在Form_Load事件的开始增加下列代码。</p>
<p>privatevoid Form1_Load(object sender, System.EventArgs e)</p>
<p>{</p>
<p>// 当缩放时禁止重绘</p>
<p>this.SetStyle(ControlStyles.EnableNotifyMessage, true);</p>
<p>// 设置标签编辑为手动方式</p>
<p>axTOCControl1.LabelEdit = esriTOCControlEdit.esriTOCControlManual;</p>
<p>// 后面是加载文档代码</p>
<p>// ……</p>
<p>2.在设计模式显示窗体并从属性窗口选择AxTOCControl1控件，显示AxTOCControl事件。双击OnEndLabelEdit向代码窗口添加事件处理函数。</p>
<p>3.在axTOCControl1_OnEndLabelEdit事件中添加以下代码：</p>
<p>privatevoid axTOCControl1_OnEndLabelEdit(object sender, ESRI.ArcGIS.TOCControl.ITOCControlEvents_OnEndLabelEditEvent e)</p>
<p>{</p>
<p>// 禁止在编辑标签时键入空字串</p>
<p>string newLabel = e.newLabel;</p>
<p>if ( newLabel.Trim() == "" )</p>
<p>{</p>
<p>e.canEdit = false;</p>
<p>}</p>
<p>}</p>
<p>4.生成并生成应用程序。编辑TOCControl控件的地图、图层、标题或图例类的标签，在其上点击一次，然后再点一次调用标签编辑。试着用空字串替代标签。在编辑期间，你可以随时使用键盘上的ESC键取消编辑。</p>
<h4>(九)在MapControl上绘制图形</h4>
<p>你可以将MapControl作为缩略图窗体使用，并在其上绘制显示PageLayoutControl内的焦点地图的当前范围。当你浏览PageLayoutControl数据框架内的数据时，你将看到缩略图窗口也进行了更新。</p>
<p><em>注：使用地图导航工具导航焦点图（活动图）将改变PageLayoutControl中焦点地图的范围并引起MapControl更新。使用页面布局工具导航页面布局将改变页面布局的范围（不是PageLayoutControl中的焦点图的范围），而MapControl将不更新。</em></p>
<p>1.向类中增加下列成员变量：</p>
<p>publicclass Form1 : System.Windows.Forms.Form</p>
<p>{</p>
<p>private ESRI.ArcGIS.MapControl.AxMapControl axMapControl1;</p>
<p>private ESRI.ArcGIS.PageLayoutControl.AxPageLayoutControl axPageLayoutControl1;</p>
<p>private ESRI.ArcGIS.TOCControl.AxTOCControl axTOCControl1;</p>
<p>private ESRI.ArcGIS.ToolbarControl.AxToolbarControl axToolbarControl1;</p>
<p>private IToolbarMenu m_ToolbarMenu = new ToolbarMenuClass(); // 弹出式菜单</p>
<p>private IEnvelope m_Envelope; // MapControl绘制的范围</p>
<p>private Object m_FillSymbol; // 在MapControl上绘制范围使用的符号</p>
<p>private ITransformEvents_VisibleBoundsUpdatedEventHandler</p>
<p>visBoundsUpdatedE; // PageLayoutControl的焦点图事件</p>
<p><em>注：声明的变量visBoundsUpdatedE是一个托管。托管是一个类，它能够拥有对指定方法的引用，并使它链接到一个特定的事件。在事件和方法之间的链接过程有时在.NET中被称作wiring。</em></p>
<p>2.创建一个叫CreateOverviewSymbol的新函数。这个函数是创建你将在MapControl中使用的符号的地方，此符号是用来描述PageLayoutControl焦点地图数据范围的。函数中增加的代码如下：</p>
<p>privatevoid CreateOverviewSymbol()</p>
<p>{</p>
<p>// 获取IRGBColor接口</p>
<p>IRgbColor color = new RgbColor();</p>
<p>// 设置颜色属性</p>
<p>color.RGB = 255;</p>
<p>// 获取ILine符号接口</p>
<p>ILineSymbol outline = new SimpleLineSymbol();</p>
<p>// 设置线符号属性</p>
<p>outline.Width = 1.5;</p>
<p>outline.Color = color;</p>
<p>// 获取IFillSymbol接口</p>
<p>ISimpleFillSymbol simpleFillSymbol =  new SimpleFillSymbolClass();</p>
<p>// 设置填充符号属性</p>
<p>simpleFillSymbol.Outline = outline;</p>
<p>simpleFillSymbol.Style = esriSimpleFillStyle.esriSFSHollow;</p>
<p>m_FillSymbol = simpleFillSymbol;</p>
<p>}</p>
<p>3.从Form_Load事件在TOCControl标签编辑代码之前调用CreateOverviewSymbol函数。</p>
<p>privatevoid Form1_Load(object sender, System.EventArgs e)</p>
<p>{</p>
<p>// 当缩放时禁止重绘</p>
<p>this.SetStyle(ControlStyles.EnableNotifyMessage, true);</p>
<p>// 创建MapControl使用的符号</p>
<p>CreateOverviewSymbol();</p>
<p>// 下面是标签编辑处理代码</p>
<p>// ……</p>
<p>}</p>
<p>4.增加下列OnVisibleBoundsUpdated函数。此函数将与地图范围改变时触发的事件相连接，并用来设置新的地图可见边界范围框。通过刷新MapControl，你强制它重绘其上显示的图形。</p>
<p>privatevoid OnVisibleBoundsUpdated(IDisplayTransformation sender, bool sizeChanged)</p>
<p>{</p>
<p>// 设置新的可见范围</p>
<p>m_Envelope = sender.VisibleBounds;</p>
<p>// 改变MapControl的前景状态</p>
<p>axMapControl1.ActiveView.PartialRefresh(</p>
<p>esriViewDrawPhase,esriViewForeground, null,  null);</p>
<p>}</p>
<p>5.PageLayoutControl默认的事件接口是IPageLayoutControlEvents。这些事件不告诉我们数据边框内的地图范围。为此你需要使用PageLayoutControl的焦点地图的ItransformEvents接口。在PageLayoutControl_OnPageLayoutReplaced事件处理中的加载文档代码前面增加以下代码。</p>
<p>privatevoid axPageLayoutControl1_OnPageLayoutReplaced(object sender, ESRI.ArcGIS.PageLayoutControl.IPageLayoutControlEvents_OnPageLayoutReplacedEvent e)</p>
<p>{</p>
<p>// 获取PageLayoutControl中焦点地图的IActiveView对象</p>
<p>IActiveView activeView = (IActiveView)</p>
<p>axPageLayoutControl1.ActiveView.FocusMap;</p>
<p>// 捕捉PageLayoutControl的焦点图的ITransformEvents事件</p>
<p>visBoundsUpdatedE =  new ITransformEvents_VisibleBoundsUpdatedEventHandler(OnVisibleBoundsUpdated);</p>
<p>((ITransformEvents_Event)activeView.ScreenDisplay</p>
<p>.DisplayTransformation).VisibleBoundsUpdated += visBoundsUpdatedE;</p>
<p>// 获取焦点图的范围</p>
<p>m_Envelope = activeView.Extent;</p>
<p>// 后面是加载地图文档的代码</p>
<p>// ……</p>
<p>6.在设计模式下显示窗体并从属性窗中选择axMapControl1，显示axMapControl事件。双击OnAfterDraw向代码窗口中增加事件处理。</p>
<p>7.向axMapControl1_OnAfterDraw事件处理中增加以下代码，使用前面创建的符号绘制MapControl显示边框。</p>
<p>privatevoid axMapControl1_OnAfterDraw(object sender, ESRI.ArcGIS.MapControl.IMapControlEvents2_OnAfterDrawEvent e)</p>
<p>{</p>
<p>if ( m_Envelope == null)</p>
<p>{</p>
<p>return;</p>
<p>}</p>
<p>// 如果前景状态被重绘</p>
<p>esriViewDrawPhase viewDrawPhase = (esriViewDrawPhase)e.viewDrawPhase;</p>
<p>if ( viewDrawPhase == esriViewDrawPhase.esriViewForeground )</p>
<p>{</p>
<p>IGeometry geometry = m_Envelope;</p>
<p>axMapControl1.DrawShape(geometry,  ref m_FillSymbol);</p>
<p>}</p>
<p>}</p>
<p>生成并运行应用程序。使用你先前已经加好的地图导航工具改变PageLayoutControl中焦点地图的范围。新的范围被绘制在MapControl上。</p>
<h4>(十)创建自定义工具</h4>
<p>创建协同MapControl和PageLayoutControl一起运作的自定义命令和工具，与你或许已经做过的创建ESRI ArcMap应用程序命令非常相似。你将创建一个在PageLayoutControl鼠标点击位置添加包含当天日期的文本元素的自定义工具。不管用何种方法，创建同MapControl和ToolbarControl协作的命令与同PageLayoutControl一样。</p>
<p>这个自定义工具的相关代码与其他本方案源代码一样很有用。如果你想要直接使用自定义命令，而不自己创建它，请直接到第24步。</p>
<p>1.从<strong>新建项目</strong>对话框创建一个新的Visual C# “类库”项目。</p>
<p>2.将项目命名为“Commands”，并选择保存位置存贮之。</p>
<p>3.单击<strong>项目</strong>菜单并选择“添加引用(R)…”。</p>
<p>4.在添加引用对话框中，复选“ESRI.ArcGIS.Carto”，“ESRI.ArcGIS.Display”，“ESRI.ArcGIS.Geometry”，“ESRI.ArcGIS.System”，“ESRI.ArcGIS.SystemUI”，“ESRI.ArcGIS..Utility”和“ESRI.ArcGIS.ControlCommands”。</p>
<p>5.在项目中增加一个类，名字叫AddDateTool。</p>
<p>6.点击<strong>项目</strong>菜单并选择<strong>添加现有项</strong>，浏览样例源码目录并找到date.bmp文件将其加入到你的项目。</p>
<p>7.在<strong>解决方案资源管理器</strong>中点击date.bmp在属性窗口显示其属性。改变<strong>生成操作</strong>属性为<strong>嵌入的资源</strong>。这张位图将被用来作为命令按钮的外观。</p>
<p>8.改变AddDateTool的命名空间的名称为CSharpDotNETCommands。</p>
<p>namespace CSharpDotNETCommands</p>
<p>{</p>
<p>……</p>
<p><em>注：要在Visual Basi .NET中改变命名空间的名称，则在<strong>解决方案资源管理器</strong>的项目上点击右键并选择<strong>属性</strong>，在项目属性页中选择常规并改变<strong>根命名空间</strong>后，按<strong>确定</strong>。</em></p>
<p>9.在AddDateTool类代码窗口的顶部增加以下引用。</p>
<p>using System;</p>
<p>using ESRI.ArcGIS.Carto;</p>
<p>using ESRI.ArcGIS.Display;</p>
<p>using ESRI.ArcGIS.Geometry;</p>
<p>using ESRI.ArcGIS.SystemUI;</p>
<p>using ESRI.ArcGIS.esriSystem;</p>
<p>using ESRI.ArcGIS.ControlCommands;</p>
<p>using ESRI.ArcGIS.Utility.BaseClasses;</p>
<p>using System.Runtime.InteropServices;</p>
<p>10.指定AddDateTool类继承自ESRI BaseTool抽象类，并增加密封（sealed）类修饰。</p>
<p>publicsealedclass AddDateTool : BaseTool</p>
<p>{</p>
<p>……</p>
<p><em>注：抽象类是不能被实例化的类，通常仅包含部分实现代码，或者不包含任何实现代码。它们与接口密切相关；但与接口有明显的区别，也就是说，一个类可能实现任意数量的接口，但它仅能够从一个抽象类中继承。继承了ESRI BaseTool抽象类，你便可以比直接实现esriSystemUI ICommand和ITool接口更快速、简便地创建命令和工具。</em></p>
<p><em>密封类修饰说明一个类不能被继承。此类的设计是为了限制其他类从该类继承。</em></p>
<p>11.向AddDateTool类的构造函数中增加下列代码：</p>
<p>publicsealedclass AddDateTool : BaseTool</p>
<p>{</p>
<p>public AddDateTool()</p>
<p>{</p>
<p>// 获取程序集中的资源数组</p>
<p>string[] res = GetType().Assembly.GetManifestResourceNames();</p>
<p>// 设置工具属性</p>
<p>base.m_bitmap = new System.Drawing.Bitmap(</p>
<p>GetType().Assembly.GetManifestResourceStream(res[0]));</p>
<p>base.m_caption = "添加日期";</p>
<p>base.m_category = "CustomCommands";</p>
<p>base.m_message = "在页面布局中增加一个日期元素";</p>
<p>base.m_name = "CustomCommands_Add Date";</p>
<p>base.m_toolTip = "添加日期";</p>
<p>}</p>
<p>}</p>
<p><em>注:类构造函数是一个当类创建时被调用的方法。它可以用来初始化类成员变量。构造函数名与类名相同；与其他方法不同的是它没有返回类型。</em></p>
<p><em>程序中只个别地替换实现了位图、标题、目录、名称、消息和提示方法，你可以设置从这此方法返回的值，且依赖于BaseTool类为这此方法提供的实现。其它的成员保留BaseTool类返回的默认值。</em></p>
<p>12.向AddDateTool类增加下列成员变量。</p>
<p>publicsealedclass AddDateTool : BaseTool</p>
<p>{</p>
<p>// HookHelper对象处理通过OnCreate事件的回调</p>
<p>private IHookHelper m_HookHelper = new HookHelperClass();</p>
<p>……</p>
<p>13.在<strong>类视图</strong>窗口中，定位到BaseCommand类的OnCreate方法，右键点击之显示上下文菜单。选择<strong>增加</strong>，然后重载并增加该方法至代码窗口。</p>
<p>14.在重载的OnCreate方法中增加以下代码。</p>
<p>publicoverridevoid OnCreate(object hook)</p>
<p>{</p>
<p>m_HookHelper.Hook = hook;</p>
<p>}</p>
<p><em>注：要在Visual Basic .NET中重载属性和方法，从代码窗口顶部的“Class Name”组合框中选择“Overrides”,从“Method Name”组合框中选择属性或方法。</em></p>
<p>15.在类视图中定位到BaseCommand类的Enabled属性并在其上点击右键显示上下文菜单。选择<strong>添加</strong>，然后点<strong>重写</strong>增加该属性至代码窗口。</p>
<p>16.增加以下代码，重写BaseTool类的默认Enabled值。</p>
<p>publicoverridebool Enabled</p>
<p>{</p>
<p>get</p>
<p>{</p>
<p>// 设置使能属性</p>
<p>if ( m_HookHelper.ActiveView != null )</p>
<p>{</p>
<p>returntrue;</p>
<p>}</p>
<p>else</p>
<p>{</p>
<p>returnfalse;</p>
<p>}</p>
<p>}</p>
<p>}</p>
<p><em>注：ICommand_OnCreate事件向命令工作的应用程序传送一个句柄或回调。在这种情况下，它可以是MapControl，PageLayoutControl或ToolbarControl。除向OnCreate事件增加代码外，你可以使用HookHelper判断传向命令的回调类型。命令或工具需要知道如何处理传送的回调，所以必须对ArcGIS Control传送的类型作检查。HookHelper用来控件回调并返回ActiveView忽略的回调类型（MapControl、PageLayoutControl和ToolbarControl都是这样）。</em></p>
<p>17.在类视图中定位到BaseTool基类的OnMouseDown方法，并在其上点击右键显示上下文菜单。选择<strong>添加</strong>，然后重载并增加该属性至代码窗口。</p>
<p>18.增加下列代码，重载BaseTool类实现的默认OnMouseDown函数。</p>
<p>publicoverridevoid OnMouseDown(int Button, int Shift, int X,  int Y)</p>
<p>{</p>
<p>// TODO: 添加 AddDateTool.OnMouseDown 实现</p>
<p>base.OnMouseDown (Button, Shift, X, Y);</p>
<p>// 获取活动视图</p>
<p>IActiveView activeView = m_HookHelper.ActiveView;</p>
<p>// 创建新的文本元素</p>
<p>ITextElement textElement = new TextElementClass();</p>
<p>// 创建文本符号</p>
<p>ITextSymbol textSymbol = new TextSymbolClass();</p>
<p>textSymbol.Size = 25;</p>
<p>// 设置文本元素属性</p>
<p>textElement.Symbol = textSymbol;</p>
<p>textElement.Text = DateTime.Now.ToShortDateString();</p>
<p>// 对IElementQI</p>
<p>IElement element = (IElement) textElement;</p>
<p>// 创建页点</p>
<p>IPoint point = new PointClass();</p>
<p>point = activeView.ScreenDisplay.DisplayTransformation.ToMapPoint(X, Y);</p>
<p>// 设置元素图形</p>
<p>element.Geometry = point;</p>
<p>// 增加元素到图形绘制容器</p>
<p>activeView.GraphicsContainer.AddElement(element, 0);</p>
<p>// 刷新图形</p>
<p>activeView.PartialRefresh(esriViewDrawPhase.esriViewGraphics,</p>
<p>null,  null);</p>
<p>}</p>
<p>19.ArcGIS Engine期望自定义命令是一个COM类；因此，你必须指定你所创建的.NET类也成为一个COM类，它是通过创建一个COM可调用包装(callable wrapper)实现的。在解决方案资源管理器窗口中，在Commands项目上右击鼠标键并从上下文菜单中选择<strong>属性</strong>。</p>
<p>20.在项目属性页对话框中选择<strong>配置属性</strong>；并点击<strong>生成</strong>。在右面的面板中，改变为“为Com Interop注册”为True，点<strong>确定</strong>。</p>
<p><em>注：设置“为Com Interop注册”属性为True会调用程序集注册工具（Regasm.exe）。这将增加客户端期望找到的类信息。</em></p>
<p><em>如果“为Com Interop注册”属性设为False，则使项目不要是一个C#类库类型。</em></p>
<p>21.在AddDateTool类的代码编写窗口的AddDateTool类声明的开始位置增加下列代码，指定COM需要的属性。</p>
<p>[ClassInterface(ClassInterfaceType.None)]</p>
<p>[Guid("D880184E-AC81-47E5-B363-781F4DC4528F")]</p>
<p><em>注：新的GUID可能通过Visual Studio .NET中的GuidGen.exe实用工具生成，或者从工具菜单中选择<strong>创建</strong></em><strong><em>GUID</em></strong><em>。GUID应该像上面的格式并不包含大括号(curly braces)。</em></p>
<p>22.向AddDateTool类成员变量的后面增加下列代码。此代码定义了一些函数，这些函数使用目录实用工具向ESRI控件命令（ESRI Control Commands）组件目录注册和取消注册AddDateTool类。</p>
<p>// 在“ESRI Controls Commands”组件目录注册</p>
<p>#region Component Category Registration</p>
<p>[ComRegisterFunction()]</p>
<p>[ComVisible(false)]</p>
<p>staticvoid RegisterFunction(String sKey)</p>
<p>{</p>
<p>string fullKey = sKey.Remove(0, 18) + @"/nImplemented Categories";</p>
<p>Microsoft.Win32.RegistryKey regKey =</p>
<p>Microsoft.Win32.Registry.ClassesRoot.OpenSubKey(fullKey, true);</p>
<p>if (regKey != null)</p>
<p>{</p>
<p>regKey.CreateSubKey("{B284D891-22EE-4F12-A0A9-B1DDED9197F4}");</p>
<p>}</p>
<p>}</p>
<p>[ComUnregisterFunction()]</p>
<p>[ComVisible(false)]</p>
<p>staticvoid UnregisterFunction(String sKey)</p>
<p>{</p>
<p>string fullKey = sKey.Remove(0, 18) + @"/Implemented Categories";</p>
<p>Microsoft.Win32.RegistryKey regKey =</p>
<p>Microsoft.Win32.Registry.ClassesRoot.OpenSubKey(fullKey, true);</p>
<p>if (regKey != null)</p>
<p>{</p>
<p>regKey.DeleteSubKey("{B284D891-22EE-4F12-A0A9-B1DDED9197F4}");</p>
<p>}</p>
<p>}</p>
<p>#endregion</p>
<p>23.生成工程。</p>
<p>24.在方案开始创建的Visual Studio .NET “Windows应用程序”项目中，增加地图导航命令代码的后面增加以下代码。</p>
<p>privatevoid Form1_Load(object sender, System.EventArgs e)</p>
<p>{</p>
<p>// 前面是命令导航代码……</p>
<p>// 添加自定义日期工具</p>
<p>progID = "CSharpDotNETCommands.AddDateTool";</p>
<p>axToolbarControl1.AddItem(progID, -1, -1, true, 0,</p>
<p>esriCommandStyles.esriCommandStyleIconAndText);</p>
<p>// 后面是ToolbarMenu相关代码……</p>
<p>}</p>
<p>25.生成并运行应用程序，使用添加日期工具向PageLayoutControl上增加一个包含当天日期的文本元素。</p>
<h4>(十一)自定义ToolbarControl</h4>
<p>同在Form_Load事件中向ToolbarControl控件增加ArcGIS Engine命令和工具一样，你也可以使用定制对话框和自定义ToolbarControl的方式添加命令和工具。要实现它，就要将ToolbarControl置为定制模式并显示定制对话框。</p>
<p>1.向类中增加下列成员变量：</p>
<p>……</p>
<p>private ITransformEvents_VisibleBoundsUpdatedEventHandler</p>
<p>visBoundsUpdatedE; // PageLayoutControl的焦点图事件</p>
<p>private ICustomizeDialog m_CustomizeDialog = new</p>
<p>CustomizeDialogClass(); // CurtomizeDialog被ToolbarControl使用</p>
<p>private ICustomizeDialogEvents_OnStartDialogEventHandler</p>
<p>startDialogE; // CustomizeDialog启动事件</p>
<p>private ICustomizeDialogEvents_OnCloseDialogEventHandler</p>
<p>closeDialogE; // CustomizeDialog关闭事件</p>
<p>……</p>
<p><em>注：Visual Studio .NET提供了当程序集对COM interop开放时执行的函数在系统中被注册和取消注册的功能。这就允许你在定制对话框可能找到的组件目录中注册你自己的类。</em></p>
<p>2.创建一个叫CreateCustomizeDialog的新函数，这个函数是你通过增加如下代码创建自定义对话框的地方。</p>
<p>privatevoid CreateCustomizeDialog()</p>
<p>{</p>
<p>// 设置自定义对话框事件</p>
<p>startDialogE =  new</p>
<p>ICustomizeDialogEvents_OnStartDialogEventHandler(OnStartDialog);</p>
<p>((ICustomizeDialogEvents_Event)m_CustomizeDialog).OnStartDialog +=</p>
<p>startDialogE;</p>
<p>closeDialogE =  new</p>
<p>ICustomizeDialogEvents_OnCloseDialogEventHandler(OnCloseDialog);</p>
<p>((ICustomizeDialogEvents_Event)m_CustomizeDialog).OnCloseDialog +=</p>
<p>closeDialogE;</p>
<p>// 设置标题</p>
<p>m_CustomizeDialog.DialogTitle = "自定义ToolbarControl项目";</p>
<p>// 显示“从文件添加”按钮</p>
<p>m_CustomizeDialog.ShowAddFromFile = true;</p>
<p>// 设置将增加新项目的ToolbarControl</p>
<p>m_CustomizeDialog.SetDoubleClickDestination(axToolbarControl1);</p>
<p>}</p>
<p><em>注：设置ComVisible属性为false确保此方法不能被COM客户端直接调用。当程序集通过COM注册时，它不影响被调用的方法。</em></p>
<p>3.在Form_Load事件中调用CreateOverviewSymbol子过程以前调用CreateCustomizeDialog函数。</p>
<p>privatevoid Form1_Load(object sender, System.EventArgs e)</p>
<p>{</p>
<p>// 当缩放时禁止重绘</p>
<p>this.SetStyle(ControlStyles.EnableNotifyMessage, true);</p>
<p>// 为ToolbarControl创建自定义对话框</p>
<p>CreateCustomizeDialog();</p>
<p>……</p>
<p>}</p>
<p>4.在窗体上增加一个名叫“chkCustomize”的复选框，并将标题命名为“定制”。</p>
<p>5.在设计模式显示窗体并从属性窗口选择chkCustomize控件，显示chkCustomize事件。在CheckedChanged事件上双击向代码窗口增加相应的事件处理。</p>
<p>6.向chkCustomize_CheckedChanged事件中增加下列代码。</p>
<p>privatevoid chkCustomize_CheckedChanged(object sender, System.EventArgs e)</p>
<p>{</p>
<p>// 显示或隐藏自定义对话框</p>
<p>if (chkCustomize.Checked == false )</p>
<p>{</p>
<p>m_CustomizeDialog.CloseDialog();</p>
<p>axToolbarControl1.Customize = false;</p>
<p>}</p>
<p>else</p>
<p>{</p>
<p>m_CustomizeDialog.StartDialog(axToolbarControl1.hWnd);</p>
<p>axToolbarControl1.Customize = true;</p>
<p>}</p>
<p>}</p>
<p>7.增加下以下OnStartDialog和OnCloseDialog事件处理函数。这些函数将与自定义对话框打开或关闭时触发的事件紧密连接。</p>
<p>privatevoid OnStartDialog()</p>
<p>{</p>
<p>axToolbarControl1.Customize = true;</p>
<p>}</p>
<p>privatevoid OnCloseDialog()</p>
<p>{</p>
<p>axToolbarControl1.Customize = false;</p>
<p>chkCustomize.Checked = false;</p>
<p>}</p>
<p>8.生成并运行应用程序，选择定制复选框使ToolbarControl进入自定义模式，并打开自定义对话框。</p>
<p>9.在自定义ToolbarControl项目对话框中的左边目录（Categories）列表中选择“Graphic Element”项，然后在右边的命令（Commands）列表中“Select Elements”项上双击将其加入到ToolbarControl工具栏中。右键点击ToolbarControl上的任何一个项目，你可以调整它的显示样式和组合特性。</p>
<p>10.结束定制应用。使用选择工具移动包含日期的文本元素。</p>
<h3>六、部署</h3>
<p>要将应用程序成功地部署到另一台机器上，必须为应用程序配置协议。首先，它必须检查产品协议是否有效，其次，它必须初始化协议。如果协议配置不正确有，应用程序将不能运行。</p>
<p><em>注：当采用ESRI ArcObjects开发独立运行的程序时，应用程序负责检查并配置协议选项。它通过实现CoClass AoInitialize和IAoInitialize接口来支持协议配置。应用程序运行时，在任何ESRI ArcObject功能被访问之前协议初始化必须先被执行。如果初始化失败将导致应用程序错误。</em></p>
<p>1.向类中增加下列成员变量。</p>
<p>publicclass Form1 : System.Windows.Forms.Form</p>
<p>{</p>
<p>private ESRI.ArcGIS.MapControl.AxMapControl axMapControl1;</p>
<p>private ESRI.ArcGIS.PageLayoutControl.AxPageLayoutControl axPageLayoutControl1;</p>
<p>private ESRI.ArcGIS.TOCControl.AxTOCControl axTOCControl1;</p>
<p>private ESRI.ArcGIS.ToolbarControl.AxToolbarControl axToolbarControl1;</p>
<p>// 应用初始化对象</p>
<p>private IAoInitialize m_AoInitialize = new AoInitializeClass();</p>
<p>// 后面是弹出菜单变量声明代码</p>
<p>……</p>
<p>2.在Form_Load事件的最开始位置增加下列代码。</p>
<p>privatevoid Form1_Load(object sender, System.EventArgs e)</p>
<p>{</p>
<p>// 创建新的AoInitialize对象</p>
<p>if ( m_AoInitialize == null)</p>
<p>{</p>
<p>System.Windows.Forms.MessageBox.Show(</p>
<p>"初始化失败，程序不能运行！");</p>
<p>this.Close();</p>
<p>}</p>
<p>// 判断产品是否有效</p>
<p>esriLicenseStatus licenseStatus = (esriLicenseStatus)</p>
<p>m_AoInitialize.IsProductCodeAvailable(</p>
<p>esriLicenseProductCode.esriLicenseProductCodeEngine);</p>
<p>if (licenseStatus == esriLicenseStatus.esriLicenseAvailable )</p>
<p>{</p>
<p>licenseStatus = (esriLicenseStatus)</p>
<p>m_AoInitialize.Initialize(esriLicenseProductCode.esriLicenseProductCodeEngine);</p>
<p>if (licenseStatus != esriLicenseStatus.esriLicenseCheckedOut )</p>
<p>{</p>
<p>System.Windows.Forms.MessageBox.Show(</p>
<p>"初始化失败，应用程序不能运行！");</p>
<p>this.Close();</p>
<p>}</p>
<p>}</p>
<p>else</p>
<p>{</p>
<p>System.Windows.Forms.MessageBox.Show(</p>
<p>"ArcGIS Engine产品无效，此程序不能运行！");</p>
<p>this.Close();</p>
<p>}</p>
<p>// 当缩放时禁止重绘</p>
<p>this.SetStyle(ControlStyles.EnableNotifyMessage, true);</p>
<p>// 后面是创建自定义对话框的代码……</p>
<p>……</p>
<p>}</p>
<p>3.在设计模式显示窗体并在属性窗口选择Form1，显示窗体事件。在Closing事件上双击向代码窗口增加事件处理代码。</p>
<p>4.在Form_Closing事件中增加以下代码：</p>
<p>privatevoid Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e)</p>
<p>{</p>
<p>// 释放COM对象并关闭AoInitialize对象</p>
<p>ESRI.ArcGIS.Utility.COMSupport.AOUninitialize.Shutdown();</p>
<p>m_AoInitialize.Shutdown();</p>
<p>}</p>
<p>5.在Release模式下生成项目和解决方案。</p>
<p>要将应用程序成功地部署到用户机器上：</p>
<p>l要将应用程序的可执行文件和包含自定义命令的动态链接库DLL发布到用户机器上。程序集注册工具（RegAsm.exe）必须被用来向注册表增加关于自定义类的信息。</p>
<p>l用户机器上需要安装有ArcGIS Engine运行时库和标准ArcGIS Engine协议。</p>
<p>l客户机上需要安装Microsoft .NET Framework 1.1。</p>
<h3>七、附加资源</h3>
<p>下列资源可以帮助你理解和应用在本方案中在在的概念和技术。</p>
<p>l在ArcGIS Engine开发工具包中包含了其他可用的文档：ArcGIS开发帮助，组件帮助，对象模型图表和适合于初学者的样例程序。</p>
<p>lArcGIS开发在线——一个Web站点，提供了最新的ArcGIS开发信息，包括程序样例和技术文档。请访问<a href="http://arcgisdeveloperonline.esri.com/" rel="external nofollow noreferrer">http://arcgisdeveloperonline.esri.com/</a></p>
<p>lESRI在线讨论组——Web站点，从其他ArcGIS开发者提供无偿援助。请访问<a href="http://support.esri.com/" rel="external nofollow noreferrer">http://support.esri.com/</a>并点击用户论坛页签。</p>
<p>l微软Visual Studio .NET开发环境中的文档。</p>
<p>转自：http://blog.csdn.net/yanleigis/article/details/2233674</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 08:03:19</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/arcengine/" title="arcengine">arcengine</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>ArcGIS Engine开发入门教程的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0n8lmz.html" rel="bookmark">ArcGIS for Desktop入门教程&lowbar;第八章&lowbar;Desktop学习资源 - ArcGIS知乎-新一代ArcGIS问答社区</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:ArcGIS for Desktop入门教程_第八章_Desktop学习资源 - ArcGIS知乎-新一代ArcGIS问答社区 1 学习资源 用户在学习和应用过程中,可以参考的资源如下: 1. ArcGIS资源中心 http://resources.arcgis.com/en/home/ 2. Esri中国在线支持中心http://support.esrichina.com.cn/ 3. ArcGIS知乎社区 http://zhihu.esrichina.com.cn/ 4. 优酷视频ht			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MY2aRlp.html" rel="bookmark">一看就懂的Android APP开发入门教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了Android APP开发入门教程,从SDK下载.开发环境搭建.代码编写.APP打包等步骤一一讲解,非常简明的一个Android APP开发入门教程,需要的朋友可以参考下 工作中有做过手机App项目,前端和android或ios程序员配合完成整个项目的开发,开发过程中与ios程序配合基本没什么问题,而android各种机子和rom的问题很多,这也让我产生了学习android和ios程序开发的兴趣.于是凌晨一点睡不着写了第一个android程序HelloAndroid,po出			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze4JrAp.html" rel="bookmark">PHP扩展开发入门教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 这篇文章主要介绍了PHP扩展开发入门教程,本文讲解了使用C语言在Linux系统下开发一个PHP扩展应该具备的最基本知识,需要的朋友可以参考下     PHP扩展开发 我准备在此系列博文中总结我有关PHP扩展开发的学习和感悟,力图简单清晰地描述在Linux系统下开发一个PHP扩展应该具备的最基本知识.水平较低,难免有错误,望指出. 准备工作 首先要获取一份PHP源码(可以从Github上签出,或者到官网上下载最新的稳定版),然后编译之.为了加快编译速度,我们推荐禁用所有额外的扩展(使用--dis			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKk63db.html" rel="bookmark">arcgis engine开发类似arcmap的功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 arcgis engine开发类似arcmap的功能 怎样在arcgis engine中开发类似arcmap中新建shapefile的功能..			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrWyOmp.html" rel="bookmark">ArcGIS for Desktop入门教程&lowbar;第五章&lowbar;ArcCatalog使用 - ArcGIS知乎-新一代ArcGIS问答社区</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:ArcGIS for Desktop入门教程_第五章_ArcCatalog使用 - ArcGIS知乎-新一代ArcGIS问答社区 1 ArcCatalog使用1.1 GIS数据 地理信息系统,就是将真实的地物或地理现象抽象为计算机可表达的简单的集合类型(比如点.线.多边形),再按其几何类型和专题信息进行分类,通过计算机技术来管理和分析这些数据.从数据的组织形式上,我们通常将其分为矢量数据和栅格数据两大类. 如上图所示,分别用矢量和栅格的形式来表达一条高速公路.我们可以清晰地发现矢量数据与栅			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze6PvNb.html" rel="bookmark">ArcGIS for Desktop入门教程&lowbar;第二章&lowbar;Desktop简介 - ArcGIS知乎-新一代ArcGIS问答社区</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:ArcGIS for Desktop入门教程_第二章_Desktop简介 - ArcGIS知乎-新一代ArcGIS问答社区 1 Desktop简介1.1 ArcGIS for Desktop ArcGIS for Desktop是ArcGIS产品线上的桌面端软件产品,为GIS专业人士提供的信息制作和使用的工具.利用ArcGIS for Desktop,你可以实现任何从简单到复杂的GIS任务,包括制图,地理分析,数据编辑,数据管理,可视化和空间处理等.它可以作为三个独立的软件产品购买,每个产			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boRAYvz.html" rel="bookmark">ArcGIS Engine开发的ArcGIS 版本管理的功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:ArcGIS Engine开发的ArcGIS 版本管理的功能 转自:http://blog.csdn.net/linghe301/article/details/7965901 这是以前的ArcGIS Engine开发成果,主要是Geodatabase方面的,模仿ArcGIS版本的流程系统环境: VS2010.ArcGIS Engine10.DevExpress721(第三方控件,比较常用易于下载)   -------------------------------------------			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXwlKvM.html" rel="bookmark">ArcGIS for Desktop入门教程&lowbar;第一章&lowbar;引言 - ArcGIS知乎-新一代ArcGIS问答社区</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:ArcGIS for Desktop入门教程_第一章_引言 - ArcGIS知乎-新一代ArcGIS问答社区 1 引言1.1 读者定位 我们假设用户在阅读本指南前应已具备以下知识: · 熟悉Windows的基本操作 · 接触过地理信息系统的概念 · 理解地理数据的特点 1.2 预期效果 我们期望用户在阅读完本指南后对以下知识有一定的了解: · 了解ArcGIS for Desktop的组成与功能 · 熟悉使用ArcGIS for Desktop进行数据编辑.整饰和输出的流程 · 如何使用A			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJk0OJb.html" rel="bookmark">ArcGIS for Desktop入门教程&lowbar;第三章&lowbar;Desktop软件安装 - ArcGIS知乎-新一代ArcGIS问答社区</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:ArcGIS for Desktop入门教程_第三章_Desktop软件安装 - ArcGIS知乎-新一代ArcGIS问答社区 1 软件安装1.1 安装前准备 请确认已经收到来自Esri中国(北京)有限公司发出的软件安装光盘及包含许可授权文件(*.prvs或 *.prvc)的电子邮件. *.prvs是浮动版的许可,*.prvc是单机版的许可.下面以浮动版许可为例,介绍软件的安装. 在安装之前,请先确认待安装软件的系统.硬件及软件环境,是否满足ArcGIS for Desktop 10.4的			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWWrAM.html" rel="bookmark" class="title">Photoshop制作非常漂亮的运动鞋海报</a>
					<div>
						这张图本来是一个春季踏青的专题页,头图是我非常喜欢的感觉,也费了不少力气做创意. 当时还在公司的时候就有同事问我这个是怎么做的了,在这里把方法分享给大家,效果看着很棒.其实方法还是比较简单的,希望对大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boB4Xz.html" rel="bookmark" class="title">交互设计实例&colon;注册和登陆的设计</a>
					<div>
						最近在做网站的注册.登陆.购买.支付等几个重要环节的流程优化和交互稿.这几个环节是与网站信息架构有关且对整个网站至关重要的.我这里讨论注册和登陆两个过程. &gt;&gt;注册过程1. 尽量简化用户注 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNEqD4b.html" rel="bookmark" class="title">ruby will&lowbar;paginate的用法</a>
					<div>
						老版本的will_paginate是基于plugin方式的,其安装方式如下:ruby script/plugin install svn://errtheblog.com/svn/plugins/wi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKmV4p.html" rel="bookmark" class="title">Java正则表达式实现条件查询浅析</a>
					<div>
						Java正则表达式实现条件查询实例是如何的呢?我们在实际开发的过程中会碰到这样子的实际需求,那么我们来看看具体的实现过程,希望对你有所帮助. Java正则表达式实现条件查询实例: //Java正则表达 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7xQ3b.html" rel="bookmark" class="title">PhotoShop CS5合成《变形金刚》海报教程</a>
					<div>
						变形金刚是美国孩之宝公司与日本TAKARA公司合作开发的系列玩具和推出的系列动画片/影片的总称,从1984年起一直风靡世界至今,本期教程中我们将制作电影海报中博派汽车人的重金属标志效果,在制作上主要利 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDAD8lb.html" rel="bookmark" class="title">用Dreamweaver为自己网站制作个性小图标</a>
					<div>
						别小看一个小小的图标,它可以充分展现出网页的个性,本实例将介绍如何在自己的个人主页上放上一个小图标. 效果说明 在地址栏上出现的已经不是微软的网页文件图标了,而变成了自己的小图标,如图 33-1 所示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk2NadM.html" rel="bookmark" class="title">PS合成教你打造宏大梦幻的玫瑰女孩</a>
					<div>
						  杰伦的世纪婚礼刚过,咱们也跟着来一篇应景的教程,学会后分分钟出婚礼大片效果,画面壮阔宏大,透视的创意运用让视觉冲击感异常强烈,非常值得学起来的一个技能,界面全中文,素材已打包,就等你练手了 &gt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBX2Lb.html" rel="bookmark" class="title">PS将普通照片调成像是夕阳下拍的那种效果</a>
					<div>
						  PS将普通照片调成像是夕阳下拍的那种效果:有个时候,自己拍照的场景不尽如人意,比如说,想在夕阳下拍一张很有韵味的照片,然奈何,夕阳晚照的情景并非天天都有,这时不在急,PS可以帮你搞定这一切,下面我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEl0aoz.html" rel="bookmark" class="title">Fast迅捷无线路由器设置图文教程</a>
					<div>
						迅捷无线路由器设置(详细设置) 一.设备的物理连接 有线连接的电脑连接路由器的LAN口,外网过来的网线连接路由器的WAN口,无线连接的通过路由器设置后通过无线功能连接到路由器.(如下图) 二.建立正确 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGamOp.html" rel="bookmark" class="title">KMPlayer播放器设置指南</a>
					<div>
						KMPlayer是一套将网路上所有能见得到的解码程式(Codec)全部 收集于一身的影音播放软体;只要安装了它,你不用再另外安装 一大堆转码程式,就能够顺利观赏所有特殊格式的影片了.除此之外,KMPl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAOERM.html" rel="bookmark" class="title">对安卓系统的功能性升级来说，安全补丁更重要！</a>
					<div>
						对安卓系统的功能性升级来说,安全补丁更重要! 很多安卓手机的使用用户可能只在意固件的安卓核心版本以及相关功能性更新,但其实相对于安卓核心版本来说刻意的追求版本号其实并不需要,因为除了 Android4 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQO4np.html" rel="bookmark" class="title">如何利用多核CPU来加速你的Linux命令 &mdash; awk&comma; sed&comma; bzip2&comma; grep&comma; wc等</a>
					<div>
						你是否曾经有过要计算一个非常大的数据(几百GB)的需求?或在里面搜索,或其它操作--一些无法并行的操作.数据专家们,我是在对你们说.你可能有一个4核或更多核的CPU,但我们合适的工具,例如 grep, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQxemz.html" rel="bookmark" class="title">离散数学 c&plus;&plus;-关于离散数学问题用c&plus;&plus;编写</a>
					<div>
						问题描述 关于离散数学问题用c++编写 给定一个谓词公式,将其转换为等价的前束范式. 用c++编写程序.求大神相助.挺难的 解决方案 http://wenku.baidu.com/link?url=6 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlBD7p.html" rel="bookmark" class="title">webgrid-WEB进销存软件中的销售单的产品明细表录入界面，大家用的是什么控件？</a>
					<div>
						问题描述 WEB进销存软件中的销售单的产品明细表录入界面,大家用的是什么控件? 类似管家婆分销ERP V3的开单界面,产品明细可以批量录入,就是一张单据有多条产品明细,后台提交到数据库,界面有计算字段 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRWqGp.html" rel="bookmark" class="title">《EDIUS 6&period;5快刀手高效剪辑技法》&mdash;&mdash;1&period;5&emsp;常用视频术语简介</a>
					<div>
						1.5 常用视频术语简介 大家都知道,在每一个行业中都有自己的术语,在EDIUS中制作视频或者影片时也使用一些专业的术语.了解视频编辑中的一些专业术语,才能更好地从事视频编辑工作.下面将简单地介绍一些 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRD7dkz.html" rel="bookmark" class="title">一个游戏引擎所应具有的元素</a>
					<div>
						原文:http://www.flipcode.com/archives/Elements_Of_A_Game_Engine.shtmlIntroduction (简介) 现在我们来说说你将如何写出一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqQjKz.html" rel="bookmark" class="title">网络扫盲贴：10秒修复消失的网关地址</a>
					<div>
						前几天收到了一名网友的求助,表示他无法正常上网,而且当他在查找断网原因之时,竟然发现默认的网关地址也消失了.面对这种情况,他表示不知该如何处理. 实际上,出现默认网关空白的情况有下面几个原因. 首先, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKY12ap.html" rel="bookmark" class="title">建议新手从最最基础的国内联盟研究入手</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 很多朋友在QQ上咨询我,说自己没有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKYQYb.html" rel="bookmark" class="title">微软最有力的竞争对手：windows xp和Internet Explorer 6</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 在操作系统和浏览器市场,你可能认为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Rw9mz.html" rel="bookmark" class="title">android 调用系统相册裁剪无效</a>
					<div>
						问题描述 android 调用系统相册裁剪无效 这是调用,打开图片后没有跳到裁剪.但如果选取图片时从图片浏览应用比如快图就可以正常裁剪并返回 为什么呢? 解决方案 Android 调用系统相册(带裁剪 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0xenM.html" rel="bookmark" class="title">数据结构 算法-线性表算法关于结构体指针的问题</a>
					<div>
						问题描述 线性表算法关于结构体指针的问题 typedef struct{ ElemType data[MAX]; int length; }SqList; //删除顺序表L中第i个位置的算法 bool ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rqVjp.html" rel="bookmark" class="title">英特尔仍对2014平板电脑四倍成长计划三缄其口</a>
					<div>
						由于最新一个季度的财报并未公布,英特尔方面仍然对其2014年平板电脑四倍成长计划的结果三缄其口. 根据其2014年前三个季度的财报计算,英特尔平板电脑芯片出货量已达3000万.也就是说,英特尔在第四季 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQDa4p.html" rel="bookmark" class="title">做好数据科学，离不开这7步</a>
					<div>
						&lt;哈佛商业评论&gt;曾宣称&quot;数据科学家&quot;是二十一世纪最性感的职业.所谓性感,既代表着难以名状的诱惑,又说明了大家对它又不甚了解. 如何做好数据科学呢? 微软高级数据科学家  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwalnM.html" rel="bookmark" class="title">slf4j-使用log4j关于不同的包使用不同的appender</a>
					<div>
						问题描述 使用log4j关于不同的包使用不同的appender 我在项目中使用的是slf4j-log4j的日志记录方法.这时发现会有很多日志信息会从我所依赖的 包里打印出来. 但是我并不想要这么多日志 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBg4rkM.html" rel="bookmark" class="title">使用C&num;如何获取本机另一个用户的HKEY&lowbar;CURRENT&lowbar;USER注册表？</a>
					<div>
						问题描述 另一个用户的用户名和密码我都已知.当然可以使用Process启动一个写好的获取HKEY_CURRENT_USER的程序,并且给定这个Process的用户名和密码,但是由于种种原因,我不想这么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myeoj8M.html" rel="bookmark" class="title">Clojure世界：如何做性能测试</a>
					<div>
						  我们经常需要在程序中测量某段代码的性能,或者某个函数的性能,在Java中,我们可能简单地循环调用某个方法多少次,然后利用System.currentTimeMillis()方法测量下时间.在Rub ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodyqdM.html" rel="bookmark" class="title">请教各位，excel&plus;VB</a>
					<div>
						问题描述 我想把excel数据读取到数据库中,连接字符串什么的都没有问题,但是光写select*from[Sheet1$],可以将excel都读出来.如果我想先加工一下,selectdistinct( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxEdD0p.html" rel="bookmark" class="title">逸动的首次公开亮相是在去年的法兰克福车展上</a>
					<div>
						长安汽车(000625,股吧)继志翔.CX30之后的第三代中级轿车EADO逸动,将于近期上市.逸动的首次公开亮相是在去年的法兰克福车展上,当时看到这款车的时候,虽然觉得设计不错,内心却以为不过是徒有其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrnRvp.html" rel="bookmark" class="title">微信开发 消息推送实现代码&lowbar;javascript技巧</a>
					<div>
						最近做微信公共号的开发,有个需求是这样的消息推送,以文本的形式把编辑的消息发送给微信企业号中的某一个应用组,这里做下笔记,以下是整理内容: //定义数据模型 public class Access_t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKLZ4M.html" rel="bookmark" class="title">asp&period;net导出Excel类库代码分享&lowbar;实用技巧</a>
					<div>
						复制代码 代码如下: using System;using System.Collections.Generic;using System.Reflection;using System.Web;us ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.086 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
